/******************************************************************************
 * 
 * Copyright 2012 - 2013 Vektor Software.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 *****************************************************************************/

package com.vektorsoft.demux.core;

import com.vektorsoft.demux.core.mva.DMXAdapter;
import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;
import org.osgi.util.tracker.ServiceTracker;

/**
 * ACtivator for <code>demux-core</code> bundle.
 * 
 * @author Vladimir Djurovic
 */
public class DemuxActivator implements BundleActivator {
    
    /** Tracker for {@code DMXAdapter} service. */
    private ServiceTracker tracker;

    /**
     * @see
     * org.osgi.framework.BundleActivator#start(org.osgi.framework.BundleContext)
     * 
     * @param context bundle context
     */
    @Override
    public void start(BundleContext context) {
       tracker = new ServiceTracker(context, DMXAdapter.class, new DemuxCoreCustomizer(context));
         tracker.open();
    }

    /**
     * @see
     * org.osgi.framework.BundleActivator#stop(org.osgi.framework.BundleContext)
     * 
     * @param context bundle context
     */
    public void stop(BundleContext context) {
    }

}
