/******************************************************************************
 * 
 * Copyright 2012 - 2013 Vektor Software.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 *****************************************************************************/

package com.vektorsoft.demux.core.resources;

/**
 * <p>
 *  Listener for application locale changes. This listener is used in conjuction with {@link ResourceManager}, 
 * which will notify listeners when locale is changed. Listeners will then handle changes to GUI as needed. Listeners
 * will be notified in case of the following events:
 * </p>
 * <ul>
 *  <li>current locale is changed</li>
 *  <li>new resource bundle is loaded</li>
 * </ul>
 *
 * @author Vladimir Djurovic
 */
public interface LocaleChangeListener {

    /**
     * Invoked when locale change occurs.
     */
    void onLocaleChange();
}
