/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */


package com.vektorsoft.demux.jfx.annotated;

import com.vektorsoft.demux.core.annotations.DMXModelData;
import com.vektorsoft.demux.core.annotations.DMXViewDeclaration;
import com.vektorsoft.demux.core.mva.DMXAdapter;
import com.vektorsoft.demux.desktop.jfx.view.JFXRootView;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.geometry.Insets;
import javafx.scene.control.Button;
import javafx.scene.layout.HBox;
import javafx.scene.paint.Color;
import javafx.scene.text.Text;

/**
 *
 * @author Vladimir Djurovic
 */
@DMXViewDeclaration (viewID = "testView", parentViewId = JFXRootView.JFX_ROOT_VIEW_ID)
public class AnnotatedView {
    
    private DMXAdapter adapter;
    
    @DMXViewDeclaration.ViewUI
    private HBox hbox;
    private Text text;
    private Button button;
    
    @DMXModelData
    private boolean testData;
    
    public AnnotatedView(DMXAdapter adapter){
       this.adapter = adapter;
    }
    
    @DMXViewDeclaration.Render
    public void renderView(){
        if(testData){
            text.setFill(Color.GREEN);
        } else {
            text.setFill(Color.RED);
        }
    }
    
    @DMXViewDeclaration.ConstructUI
    public void createUI(){
         hbox = new HBox();
        text = new Text("Hello, DEMUX!");
        button = new Button("Click me");
        hbox.getChildren().add(text);
        hbox.getChildren().add(button);
        hbox.setPadding(new Insets(5, 10, 15, 20));
        
        button.setOnAction(new EventHandler<ActionEvent>() {

            @Override
            public void handle(ActionEvent t) {
                adapter.invokeController("com.vektorsoft.demux.samples.annotated.HelloController");
            }
        });
    }
    
    public void setTestData(boolean data){
	testData = data;
    }
    
    public boolean getTestData(){
	return testData;
    }
    
    public HBox getHbox(){
      return hbox;
    }

}
