/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */


package com.vektorsoft.demux.samples.dlg.android;

import android.content.Context;
import android.support.v4.app.DialogFragment;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;
import com.vektorsoft.demux.android.core.app.DMXAndroidViewManager;
import com.vektorsoft.demux.android.core.gui.DMXAndroidDialog;
import com.vektorsoft.demux.android.core.gui.DMXAndroidDialogFactory;
import com.vektorsoft.demux.android.core.gui.DMXAndroidOptionsDialog;
import com.vektorsoft.demux.android.core.gui.DMXDefaultCallback;
import com.vektorsoft.demux.android.core.gui.DMXDialogOptionCallback;
import com.vektorsoft.demux.core.annotations.DMXModelData;
import com.vektorsoft.demux.core.annotations.DMXViewDeclaration;
import com.vektorsoft.demux.core.dlg.DMXDialog;
import com.vektorsoft.demux.core.mva.DMXAdapter;


/**
 *
 * @author Vladimir Djurovic
 */
@DMXViewDeclaration (viewID = "mainView", parentViewId = DMXAndroidViewManager.DMX_ANDROID_ROOT_VIEW)
public class AndroidMainView {
    
    private static final String LOG_TAG = "Main_View";
    
    @DMXViewDeclaration.ViewUI
    private LinearLayout root;
    private TextView name;
    private Button changeButton;
    private Button optionsButton;
    
    private DMXAdapter adapter;
    private Context ctx;
    
    @DMXModelData
    private String username;
    

    public AndroidMainView(Context ctx, DMXAdapter adapter){
	this.ctx = ctx;
	this.adapter = adapter;
    }
    
    @DMXViewDeclaration.Render
    public void renderView(){
        name.setText("Username: " + username);
    }
    
    @DMXViewDeclaration.ConstructUI
    public void makeUI(){
        root = new LinearLayout(ctx);
        root.setOrientation(LinearLayout.HORIZONTAL);
        
        name = new TextView(ctx);
        name.setText("Username: ");
        root.addView(name);
        
        changeButton = new Button(ctx);
        changeButton.setText("Change");
        changeButton.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View view) {
                DMXAndroidDialogFactory factory = adapter.getDialogFactory(DMXAndroidDialogFactory.class);
                DMXAndroidDialog dlg = factory.createDialog("simpleDialog", "Changed title");
                dlg.showDialog();
                
            }
        });
        root.addView(changeButton);
        
        optionsButton = new Button(ctx);
        optionsButton.setText("Options");
        optionsButton.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View view) {
                DMXAndroidDialogFactory factory = adapter.getDialogFactory(DMXAndroidDialogFactory.class);
                DMXAndroidOptionsDialog dlg = factory.createOptionsDialog("Options", "This is options dialog.", new String[]{"Pos", "Neg", "Neutral"});
                dlg.setCallback(new DMXDefaultCallback(){

                    @Override
                    public void onPositiveButton(DialogFragment fragment) {
                        System.out.println("Positive button");
                    }
                    
                });
                int result = dlg.showDialog();
                System.out.println("Option: " + result);
            }
        });
        root.addView(optionsButton);
    }
    
    public LinearLayout getRoot(){
      return root;
    }
    
    public void setUsername(String name){
      this.username = name;
    }
    
    public String getUsername(){
      return username;
    }
}
