/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */


package com.vektorsoft.demux.samples.dlg.android;

import android.content.Context;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.TextView;
import com.vektorsoft.demux.core.annotations.DMXDialogResult;
import com.vektorsoft.demux.core.annotations.DMXModelData;
import com.vektorsoft.demux.core.annotations.DMXViewDeclaration;
import com.vektorsoft.demux.core.dlg.DMXDialog;
import com.vektorsoft.demux.core.mva.DMXAdapter;


/**
 *
 * @author Vladimir Djurovic
 */
@DMXViewDeclaration (viewID = "simpleDialog", parentViewId = "", isDialog = true, title = "My Dialog")
public class SimpleDialogView {

     @DMXModelData
    private String username;
     
     @DMXViewDeclaration.ViewUI
     private LinearLayout root;
     private EditText field;
     private Button submit;
     
     
     private Context ctx;
     private DMXDialog dialog;
     private DMXAdapter adapter;
     
    
    public SimpleDialogView(Context ctx, DMXAdapter adapter){
      this.ctx = ctx;
      this.adapter = adapter;
      
    }

    @DMXDialogResult
    public Object getResult() {
        return field.getText().toString();
    }

    @DMXViewDeclaration.Render
    public void render() {
        field.setText(username);
    }
    
    @DMXViewDeclaration.ConstructUI
    public void makeUI(){
	 root = new LinearLayout(ctx);
       root.setOrientation(LinearLayout.HORIZONTAL);
       
        TextView label = new TextView(ctx);
        label.setText("Enter name:");
        root.addView(label);
        
        field = new EditText(ctx);
        root.addView(field);
        
        submit = new Button(ctx);
        submit.setText("Submit");
        submit.setOnClickListener(new View.OnClickListener() {

           @Override
           public void onClick(View view) {
               dialog.closeDialog();
               adapter.invokeController("namectrl", getResult());
           }
       });
        root.addView(submit);
    }
    
    public LinearLayout getRoot(){
      return root;
    }
    
    public void setUsername(String name){
      this.username = name;
    }
    
    public String getUsername(){
      return username;
    }
    
    public void setDialog(DMXDialog dlg){
      this.dialog = dlg;
    }
    
    public DMXDialog getDialog(){
      return dialog;
    }
}
