/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */


package com.vektorsoft.demux.samples.extension.jfx;

import com.vektorsoft.demux.core.annotations.DMXModelData;
import com.vektorsoft.demux.core.annotations.DMXViewDeclaration;
import com.vektorsoft.demux.core.extension.DMXExtendable;
import com.vektorsoft.demux.core.extension.DMXExtensionCallback;
import com.vektorsoft.demux.core.mva.DMXAdapter;
import com.vektorsoft.demux.core.resources.ResourceHandlerType;
import com.vektorsoft.demux.core.resources.impl.DefaultResourceHandler;
import com.vektorsoft.demux.desktop.jfx.view.JFXRootView;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.geometry.Insets;
import javafx.scene.control.Button;
import javafx.scene.layout.HBox;
import javafx.scene.layout.VBox;
import javafx.scene.paint.Color;
import javafx.scene.text.Text;

/**
 *
 * @author Vladimir Djurovic
 */
@DMXViewDeclaration (parentViewId = JFXRootView.JFX_ROOT_VIEW_ID, viewID = "extendableView")
public class ExtendableView implements DMXExtendable {
    
    @DMXModelData
    private boolean status;
    
//    @DMXModelData
//    private int random;
    
    private DMXAdapter adapter;
    
    @DMXViewDeclaration.ViewUI
    private VBox root;
    private HBox hbox;
    private Text label;
    private Button button;
    
    private SimpleViewCallback callback;
    
    private DefaultResourceHandler handler;
    
    public ExtendableView(DMXAdapter adapter){
    this.adapter = adapter;
    handler = adapter.getResourceManager().getResourceHandler(ResourceHandlerType.RESOURCE_BUNDLE);
       
    }
    
    @DMXViewDeclaration.ConstructUI
    public void makeUI(){
       root = new VBox();
       
       hbox = new HBox();
       root.getChildren().add(hbox);
       label = new Text("");
       button = new Button("Change");
       hbox.getChildren().add(label);
       hbox.getChildren().add(button);
       hbox.setPadding(new Insets(5, 10, 15, 20));
        
       button.setOnAction(new EventHandler<ActionEvent>() {

            @Override
            public void handle(ActionEvent t) {
                ExtendableView.this.adapter.invokeController("extController", "param");
            }
        });
    }
    
    @DMXViewDeclaration.Render
    public void render(){
        label.setText(handler.getString("string.hello"));
        if(status){
            label.setFill(Color.GREEN);
        } else {
            label.setFill(Color.RED);
        }
        // render extension
        if(callback != null){
            callback.render();
        }
    }

    @Override
    public void setExtensionCallback(DMXExtensionCallback callback) {
        this.callback = (SimpleViewCallback)callback;
        if(this.callback.getSubviewRoot() != null){
            root.getChildren().add(this.callback.getSubviewRoot());
        }
    }

    @Override
    public String getCallbackClassName() {
        return SimpleViewCallback.class.getName();
    }

    @Override
    public DMXExtensionCallback getExtensionCallback() {
        return callback;
    }

    public VBox getRoot(){
      return root;
    }

     public boolean getStatus(){
      return status;
    }
    
    public void setStatus(boolean status){
      this.status = status;
    }
}
