/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */


package com.vektorsoft.demux.samples.gui;

import com.vektorsoft.demux.core.annotations.DMXViewDeclaration;
import com.vektorsoft.demux.core.mva.DMXAdapter;
import com.vektorsoft.demux.core.resources.ResourceHandlerType;
import com.vektorsoft.demux.core.resources.impl.DMXResourceBundle;
import com.vektorsoft.demux.core.resources.impl.DefaultResourceHandler;
import com.vektorsoft.demux.desktop.jfx.view.JFXRootView;
import java.io.IOException;
import javafx.fxml.FXMLLoader;
import javafx.scene.layout.BorderPane;

/**
 * View which constructs it's UI from FXML file.
 *
 * @author Vladimir Djurovic
 */
@DMXViewDeclaration (parentViewId = JFXRootView.JFX_ROOT_VIEW_ID, viewID = "fxmlView")
public class FXMLView {

    private DMXAdapter adapter;
    
    @DMXViewDeclaration.ViewUI
    private BorderPane pane;
    
    public FXMLView(DMXAdapter adapter){
        this.adapter = adapter;
    }
    
    @DMXViewDeclaration.ConstructUI
    public void createUI(){
        try{
            FXMLLoader loader = new FXMLLoader();
            DefaultResourceHandler handler = adapter.getResourceManager().getResourceHandler(ResourceHandlerType.RESOURCE_BUNDLE);
            loader.setResources(new DMXResourceBundle(handler));
            pane = (BorderPane)loader.load(this.getClass().getClassLoader().getResourceAsStream("/fxmlview.xml"));
        } catch(IOException ex){
            ex.printStackTrace(System.err);
        }
        
    }
    
    @DMXViewDeclaration.Render
    public void render(){
        
    }

    public BorderPane getPane() {
        return pane;
    }
    
}
