/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */


package com.vektorsoft.demux.samples.gui;


import com.vektorsoft.demux.desktop.gui.DMXMenuService;
import javafx.scene.control.Menu;
import javafx.scene.control.MenuItem;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;
import org.osgi.util.tracker.ServiceTrackerCustomizer;

/**
 *
 * @author Vladimir Djurovic
 */
public class MenuServiceTracker implements ServiceTrackerCustomizer<DMXMenuService, DMXMenuService<Menu, MenuItem>>{
    
    private BundleContext ctx;
    
    public MenuServiceTracker(BundleContext ctx){
        this.ctx = ctx;
    }

    @Override
    public DMXMenuService<Menu, MenuItem> addingService(ServiceReference<DMXMenuService> sr) {
        DMXMenuService<Menu, MenuItem> svc = ctx.getService(sr);
        System.out.println("Found menu service");
        
        Menu file = new Menu("File");
        file.setId("file");
        svc.appendToMenuBar(file);
        
        
        Menu tools = new Menu("Tools");
        tools.setId("tools");
        svc.appendToMenuBar(tools);
        
        Menu edit = new Menu("Edit");
        svc.addAfterMenu("file", edit);
        
        Menu view = new Menu("View");
        view.setId("view");
        svc.insertAtIndex(2, view);
        
        // add menu items
        MenuItem fileNew = new MenuItem("New...");
        fileNew.setId("newFileItem");
        svc.addMenuItemToMenu("file", fileNew);
        MenuItem fileClose = new MenuItem("Close");
        svc.addMenuItemToMenu("file", fileClose);
        
        // add submenu
        Menu zoom = new Menu("Zoom");
        MenuItem zoomIn = new MenuItem("Zoom In");
        zoomIn.setId("zoomIn");
        MenuItem zoomOut = new MenuItem("Zoom Out");
        zoomOut.setId("zoomOut");
        zoom.getItems().addAll(zoomIn, zoomOut);
        svc.addSubmenuToMenu("view", zoom);
        
        // add menu item at specified position
        MenuItem fileOpen = new MenuItem("Open...");
        svc.insertMenuItem("file", 1, fileOpen);
        
        MenuItem fileExit = new MenuItem("Exit");
        svc.addMenuItemToMenu("file", fileExit);
        
        svc.insertSeparator("file", 3);
        
        svc.registerControllerForAction("zoomIn", "menuController");
        
        return svc;
    }

    @Override
    public void modifiedService(ServiceReference<DMXMenuService> sr, DMXMenuService<Menu, MenuItem> t) {
        
    }

    @Override
    public void removedService(ServiceReference<DMXMenuService> sr, DMXMenuService<Menu, MenuItem> t) {
        
    }

}
