
package com.vektorsoft.demux.samples.gui;

import com.vektorsoft.demux.core.app.DMXAbstractActivator;
import com.vektorsoft.demux.core.app.DMXAdapterTrackerHandler;
import org.osgi.framework.BundleContext;
import com.vektorsoft.demux.desktop.gui.DMXMenuService;
import com.vektorsoft.demux.desktop.gui.DMXToolbarService;
import org.osgi.util.tracker.ServiceTracker;

/**
 *
 * An implementation of {@code com.vektorsoft.demux.core.app.DMXAbstractActivator} class. This class contains logic needed
 * for supporting extension callbacks. Use this class as a starting point for you bundle activators.
 *
 * This class uses {@code SampleTrackerHandler} to track registration of {@code DMXAdapter} service.
 * 
 */
public class SampleActivator extends DMXAbstractActivator {
    
    private ServiceTracker mennuTracker;
    private ServiceTracker toolbarTracker;

    @Override
    protected void onBundleStart(BundleContext ctx) {
       mennuTracker = new ServiceTracker(ctx, DMXMenuService.class, new MenuServiceTracker(ctx));
         mennuTracker.open();
         
         toolbarTracker = new ServiceTracker(ctx, DMXToolbarService.class, new ToolbarServiceCustomizer(ctx));
         toolbarTracker.open();
    }

    @Override
    protected void onBundleStop(BundleContext ctx) {
       // add here logic required to run when bundle stops   
    }

    @Override
    public DMXAdapterTrackerHandler getHandler() {
        return new SampleTrackerHandler();
    }

}
