/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */


package com.vektorsoft.demux.samples.gui;

import com.vektorsoft.demux.desktop.gui.DMXToolbarService;
import javafx.geometry.Orientation;
import javafx.scene.control.Button;
import javafx.scene.control.Separator;
import javafx.scene.control.ToolBar;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;
import org.osgi.util.tracker.ServiceTrackerCustomizer;

/**
 *
 * @author Vladimir Djurovic
 */
public class ToolbarServiceCustomizer implements ServiceTrackerCustomizer<DMXToolbarService, DMXToolbarService<ToolBar>>{
    
    private BundleContext context;
    
    public ToolbarServiceCustomizer(BundleContext context){
        this.context = context;
    }

    @Override
    public DMXToolbarService<ToolBar> addingService(ServiceReference<DMXToolbarService> sr) {
        DMXToolbarService<ToolBar> svc = context.getService(sr);
        
        svc.setToolbarStyle("-fx-background-color: #336699;");
        
        Button b1 = new Button("Button");
        b1.setId("toolbarB1");
        Button b2 = new Button("B2");
        ToolBar toolbar = new ToolBar(b1, b2);
        svc.addToolbar( toolbar);
        
        Button b3 = new Button("B3");
        Separator sep = new Separator(Orientation.VERTICAL);
        Button b4 = new Button("B4");
        ToolBar toolbar1 = new ToolBar(b3, sep, b4);
        svc.addToolbar(toolbar1);
        
        Button b5 = new Button("B 5");
        Button b6 = new Button("B 6");
        ToolBar toolbar3 = new ToolBar(b5, b6);
        
        svc.insertToolbarAtIndex(1, toolbar3);
        
        return svc;
    }

    @Override
    public void modifiedService(ServiceReference<DMXToolbarService> sr, DMXToolbarService<ToolBar> t) {
        
    }

    @Override
    public void removedService(ServiceReference<DMXToolbarService> sr, DMXToolbarService<ToolBar> t) {
        
    }

}
