/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */


package com.vektorsoft.demux.samples.view.activation.android;

import android.content.Context;
import android.view.View;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;
import com.vektorsoft.demux.android.core.app.DMXAndroidViewManager;
import com.vektorsoft.demux.core.annotations.DMXViewDeclaration;
import com.vektorsoft.demux.core.app.DMXCoreConstants;
import com.vektorsoft.demux.core.mva.DMXAdapter;

/**
 *
 * @author Vladimir Djurovic
 */
@DMXViewDeclaration (parentViewId = DMXAndroidViewManager.DMX_ANDROID_ROOT_VIEW, viewID = "view-three")
public class ViewThree {
    
    private DMXAdapter adapter;
    private Context context;
    
    @DMXViewDeclaration.ViewUI
    private LinearLayout root;
    
    private Button button;
//    private Button dlgButton;
    
    public ViewThree(Context context, DMXAdapter adapter){
        this.adapter = adapter;
        this.context = context;
    }
    
    @DMXViewDeclaration.ConstructUI
    public void createUI(){
        root = new LinearLayout(context);
        root.setOrientation(LinearLayout.VERTICAL);
        
        TextView text = new TextView(context);
        text.setText("This is view three");
        root.addView(text);
        
        button = new Button(context);
        button.setText("Show view number 1");
        button.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View view) {
                adapter.invokeController(DMXCoreConstants.CTRL_VIEW_ACITVATION, "view-one");
            }
        });
        root.addView(button);
    }

    public LinearLayout getRoot() {
        return root;
    }

    public void setRoot(LinearLayout root) {
        this.root = root;
    }
    
    @DMXViewDeclaration.Render
    public void render(){
        
    }
    
    
    @DMXViewDeclaration.PlacementConstraint
    public Integer constraint(){
        return 10;
    }
    

}
